## dpkg 1.21.9ubuntu1

=== debian/changelog ===
dpkg (1.21.9ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Special-case arm{el,hf} ELF objects in Shlibs/Objdump.pm for multilib.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
    - dpkg-gencontrol: Fix Package-Type override handling for ddeb support.
    - Add Zstd compression and decompression support for binary packages.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'nocheck' in build options by default
      on Ubuntu/riscv64.  Overridable in debian/rules with
      'DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))'.
    - scripts/Dpkg/Vendor/Ubuntu.pm, scripts/dpkg-buildpackage.pl:
      Set 'nocheck' for riscv64 using a new 'update-buildopts' hook and make
      it effective with old style debhelper, too.
    - Dpkg::Vendor::Debian: Add new lto feature in new optimize area, taken
      from
      https://git.hadrons.org/cgit/debian/dpkg/dpkg.git/log/?h=next/1.21.x
    - dpkg-dev: Depend on lto-disabled-list.
    - dpkg-buildflags: Read package source names from lto-disabled-list,
      to build without lto optimizations. When adding a source package to the
      list, please also file a launchpad issue and tag it with 'lto'.
    - Turn on LTO optimizations on amd64, arm64, ppc64el, s390x.
      See https://wiki.ubuntu.com/ToolChain/LTO for more information.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
      default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
      will be stripped, and thus building with udebs.
    - build: Switch default dpkg-deb compression from xz to zstd.
      Keep compressing dpkg.deb with xz to help bootstrapping on non-Ubuntu
      systems.
    - Don't install dpkg-fsys-usrunmess script.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 03 Jul 2022 00:00:34 +0200

dpkg (1.21.9) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-deb: Add support for --threads-max and DPKG_DEB_THREADS_MAX.
    Prompted by vv221 on IRC.
  * Perl modules:
    - Dpkg::Source::Package::V2: Always fix the permissions for upstream
      tarballs. Closes: #1012195
    - Dpkg::BuildFlags: Document optimize feature area.
  * Documentation:
    - man: Clarify that statoverrides do not need to be known to dpkg.
      Closes: #1011510
    - man: Expand Protected and Essential field use cases. Closes: #1008780
    - doc: Rename frontend.txt to frontend-api.txt.
    - doc: Move specifications under doc/spec.
    - man: Add references to rootless-builds.txt spec.
  * Code internals:
    - libdpkg: Refactor command actions for compression.
  * Build system:
    - Split the test-runner into its own script.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

 -- Guillem Jover <guillem@debian.org>  Fri, 01 Jul 2022 11:25:58 +0200

dpkg (1.21.8ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Special-case arm{el,hf} ELF objects in Shlibs/Objdump.pm for multilib.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
    - dpkg-gencontrol: Fix Package-Type override handling for ddeb support.
    - Add Zstd compression and decompression support for binary packages.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'nocheck' in build options by default
      on Ubuntu/riscv64.  Overridable in debian/rules with
      'DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))'.
    - scripts/Dpkg/Vendor/Ubuntu.pm, scripts/dpkg-buildpackage.pl:
      Set 'nocheck' for riscv64 using a new 'update-buildopts' hook and make
      it effective with old style debhelper, too.
    - Dpkg::Vendor::Debian: Add new lto feature in new optimize area, taken
      from
      https://git.hadrons.org/cgit/debian/dpkg/dpkg.git/log/?h=next/1.21.x
    - dpkg-dev: Depend on lto-disabled-list.
    - dpkg-buildflags: Read package source names from lto-disabled-list,
      to build without lto optimizations. When adding a source package to the
      list, please also file a launchpad issue and tag it with 'lto'.
    - Turn on LTO optimizations on amd64, arm64, ppc64el, s390x.
      See https://wiki.ubuntu.com/ToolChain/LTO for more information.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
      default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
      will be stripped, and thus building with udebs.
    - build: Switch default dpkg-deb compression from xz to zstd.
      Keep compressing dpkg.deb with xz to help bootstrapping on non-Ubuntu
      systems.
    - Don't install dpkg-fsys-usrunmess script.


