=== debian/control ===
--- 
+++ 
@@ -16,9 +16,7 @@
 # Needed for --porefs defaults, conditional addenda and mode=eof.
  po4a (>= 0.59),
  zlib1g-dev,
- zstd,
  libbz2-dev,
- libzstd-dev,
  liblzma-dev,
  libselinux1-dev [linux-any],
  libncurses-dev (>= 6.1+20180210) | libncursesw5-dev,
@@ -58,7 +56,6 @@
 Depends:
  ${misc:Depends},
  zlib1g-dev,
- libzstd-dev,
  liblzma-dev,
  libbz2-dev,
 Description: Debian package management static library
@@ -85,7 +82,6 @@
  patch (>= 2.7),
  make,
  binutils,
- lto-disabled-list,
 Recommends:
  build-essential,
  gcc | c-compiler,
