=== debian/rules ===
--- 
+++ 
@@ -52,7 +52,6 @@
 		--with-devlibdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
 		--without-libmd \
 		--with-libz \
-		--with-libzstd \
 		--with-liblzma \
 		--with-libbz2 \
 		# EOL
@@ -81,10 +80,3 @@
 
 override_dh_bugfiles:
 	dh_bugfiles -A
-
-override_dh_builddeb:
-	# Make debootstrap life easier on non-Debian based systems by
-	# compressing dpkg.deb with xz instead of zstd.
-	dh_builddeb -pdpkg -- -Zxz
-	dh_builddeb -a -Ndpkg
-	dh_builddeb
