## dpkg 1.21.11

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Homepage: https://wiki.debian.org/Teams/Dpkg
 Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
 Vcs-Git: https://git.dpkg.org/git/dpkg/dpkg.git
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
@@ -15,14 +15,38 @@
  gettext (>= 0.19.7),
 # Needed for --porefs defaults, conditional addenda and mode=eof.
  po4a (>= 0.59),
+ libmd-dev,
  zlib1g-dev,
  libbz2-dev,
  liblzma-dev,
  libselinux1-dev [linux-any],
- libncurses-dev (>= 6.1+20180210) | libncursesw5-dev,
+ libncurses-dev (>= 6.1+20180210),
 # Needed for the functional test.
  bzip2 <!nocheck>,
  xz-utils <!nocheck>,
+# Needed for the author release process.
+ git <pkg.dpkg.author-release>,
+ ca-certificates <pkg.dpkg.author-release>,
+ libmodule-build-perl <pkg.dpkg.author-release>,
+# Needed for the test suite in author mode.
+ fakeroot <pkg.dpkg.author-testing>,
+ gnupg <pkg.dpkg.author-testing>,
+ cppcheck <pkg.dpkg.author-testing>,
+ shellcheck <pkg.dpkg.author-testing>,
+ aspell <pkg.dpkg.author-testing>,
+ aspell-en <pkg.dpkg.author-testing>,
+ codespell <pkg.dpkg.author-testing>,
+ i18nspector <pkg.dpkg.author-testing>,
+ libtest-minimumversion-perl <pkg.dpkg.author-testing>,
+ libtest-perl-critic-perl <pkg.dpkg.author-testing>,
+ libtest-pod-coverage-perl <pkg.dpkg.author-testing>,
+ libtest-pod-perl <pkg.dpkg.author-testing>,
+ libtest-spelling-perl <pkg.dpkg.author-testing>,
+ libtest-strict-perl <pkg.dpkg.author-testing>,
+ libtest-synopsis-perl <pkg.dpkg.author-testing>,
+# Needed for code coverage reports.
+ lcov <pkg.dpkg.code-coverage>,
+ libdevel-cover-perl <pkg.dpkg.code-coverage>,
 
 Package: dpkg
 Architecture: any
@@ -86,8 +110,8 @@
  build-essential,
  gcc | c-compiler,
  fakeroot,
- gnupg,
- gpgv,
+ gnupg | sq | pgpainless-cli,
+ gpgv | sq | pgpainless-cli,
 # Used by dpkg-mergechangelogs.
  libalgorithm-merge-perl,
 Suggests:
@@ -95,6 +119,11 @@
 Breaks:
 # Force R³ support, w/o requiring debhelper users to depend on dpkg-dev.
  debhelper (<< 10.10.1~),
+# Uses new sq features, w/o requiring a hard dependency on sq.
+ sq (<< 0.25.0~),
+# Uses required SOP feautres, w/o requiring a hard dependency on pgpainless.
+ pgpainless-cli (<< 1.3.13~),
+ libsop-java-java (<< 4.0.7~),
 Description: Debian package development tools
  This package provides the development tools (including dpkg-source)
  required to unpack, build and upload Debian source packages.
@@ -121,8 +150,8 @@
  xz-utils,
 Suggests:
  debian-keyring,
- gnupg,
- gpgv,
+ gnupg | sq | pgpainless-cli,
+ gpgv | sq | pgpainless-cli,
  gcc | c-compiler,
  binutils,
  patch,
@@ -139,6 +168,11 @@
 # Uses Dpkg::Compression::Process imported from Dpkg::Source::Package in
 # versions prior to 1.19.0.
  dgit (<< 3.13~),
+# Uses new sq features, w/o requiring a hard dependency on sq.
+ sq (<< 0.25.0~),
+# Uses required SOP feautres, w/o requiring a hard dependency on pgpainless.
+ pgpainless-cli (<< 1.3.13~),
+ libsop-java-java (<< 4.0.7~),
 Description: Dpkg perl modules
  This package provides the perl modules used by the scripts
  in dpkg-dev. They cover a wide range of functionality. Among them
@@ -197,6 +231,7 @@
  ${shlibs:Depends},
  ${misc:Depends},
 Suggests:
+ libdpkg-perl,
  perl,
 Description: Debian package management front-end
  dselect is a high-level interface for managing the installation and
