=== debian/rules ===
--- 
+++ 
@@ -50,7 +50,6 @@
 		--sbindir=/sbin \
 		--libexecdir=\$${exec_prefix}/lib \
 		--with-devlibdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
-		--without-libmd \
 		--with-libz \
 		--with-liblzma \
 		--with-libbz2 \
@@ -80,3 +79,6 @@
 
 override_dh_bugfiles:
 	dh_bugfiles -A
+
+override_dh_compress:
+	dh_compress -Xspec/
