## dpkg 1.21.12

=== debian/changelog ===
dpkg (1.21.12) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-architecture: Properly compute required information to gather.
    Reported by Sören Tempel <soeren@soeren-tempel.net>.
  * Code internals:
    - dpkg-architecture: Rename information tracking constants and variables.
  * Packaging:
    - Set paths for configure in autopkgtests to match installed ones.
    - Add libmd-dev to libdpkg-dev Depends.
      Reported by Alexandre Detiste <alexandre.detiste@gmail.com>.

 -- Guillem Jover <guillem@debian.org>  Tue, 06 Dec 2022 04:27:57 +0100

dpkg (1.21.11) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-genbuildinfo: Do not fail if there is no cross-comiler.
    Closes: #1025273
  * Documentation:
    - doc: Update Doxyfile after code reorganization.
    - doc: Update Doxygen configuration from version 1.9.4.
    - man: Remove B<> or replace with S< >.
  * Code internals:
    - libdpkg: Document str_end parameter for str_strip_quotes().
  * Packaging:
    - Add libmd-dev to the test-root and test-not-root autopkgtests.
    - Add source lintian-overrides.
    - Remove obsolete libncursesw5-dev alternative from Build-Depends.
    - Update copyright years.
  * Localization:
    - Unfuzzy translations after markup fixes.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

 -- Guillem Jover <guillem@debian.org>  Sat, 03 Dec 2022 00:18:29 +0100

dpkg (1.21.10) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg: Avoid setgid(2) call if not needed.
    Thanks to Christian Göttsche <cgzones@googlemail.com>. Closes: #1014332
  * dpkg-architecture: Do not compute values that are not required.
  * dpkg-buildpackage: Fix swapped long options for -m/-e.
  * dpkg-buildpackage: Add --source-by and --changed-by aliases for -m/-e.
  * dpkg-deb: Add support for DPKG_DEB_COMPRESSOR_TYPE/LEVEL. Closes: #550475
  * dpkg-genbuildinfo: Refactor build-tainted-by gathering into a function.
  * dpkg-genbuildinfo: Add new can-execute-cross-built-programs tainted flag.
    Thanks to Johannes Schauer Marin Rodrigues <josch@mister-muffin.de>.
    Closes: #1011191
  * dpkg: Make -E also take into account the architecture.
    Thanks to Ian Jackson <ijackson@chiark.greenend.org.uk>. Closes: #1014476
  * dpkg-source: Fix confusing regex match for option arguments.
  * dpkg-buildpackage: Fix --jobs and --jobs-try parsing with no «=».
  * dpkg-buildpackage: Rename --jobs/--jobs-try argument in --help output.
  * dpkg-buildpackage: Add new --jobs-force option.
  * dpkg-buildpackage: Change -j, --jobs semantics to non-force mode.
    Closes: #905835
  * dpkg, dpkg-statoverride: Install SELinux log callback to filter messages.
    Thanks to Christian Göttsche <cgzones@googlemail.com>.
  * dselect: Clarify non-free section as optional not free software component.
    Closes: #30972
  * dselect: Require the Dpkg modules for the ftp access method.
  * dpkg-buildpackage: Remove blank line around signfile output lines.
  * dpkg-buildpackage: Add new --sign-keyid and alias --sign-key to it.
  * dpkg-buildpackage: Add --sign-keyfile and DEB_SIGN_KEYFILE support.
  * dpkg-buildpackage: Add --sign-backend to specify the OpenPGP backend.
  * dpkg-source: Translate source format specific --help option descriptions.
  * dpkg-shlibdeps: Cache soname check against shlibs files. Closes: #1022766
  * libdpkg, dpkg: Switch triggers database to use reproducible package names.
    Closes: #990712
  * update-alternatives: Switch point at which we increment alternative
    refcount.
  * dpkg: Fix setting admindir when root is set.
  * dpkg-split: Add support for --root and --admindir.
  * Architecture support:
    - Move i386 and ia64 in an alphabetical-ish order in the cputable.
    - Add support for loong64 CPU.
      Based on a patch by 张丹丹 <zhangdandan@loongson.cn>. Closes: #1023486
  * Perl modules:
    - Dpkg::Source::Package::V1: Remove redundant exit handler for erasedir().
    - Dpkg::Source::Package::V2: Update and clarify patch header metadata
      template.
    - Dpkg::Deps: Merge dependency string into a single line when parsing.
      Closes: #1019565
    - Dselect::Ftp: Switch to current mirror list for ftp method output.
    - Dpkg::Source::Package: Use File::Spec instead of ad-hoc concatenation.
    - Dpkg::Source::Package: Verify signatures before printing source files
      addition.
    - Dpkg::Source::Package: Print verifying signature for all source formats.
    - Dpkg::Vendor: Rename @tries variable to @names.
    - Dpkg::Vendor: Fix get_vendor_file() to return on first match.
      Reported by Niels Thykier <niels@thykier.net> (on IRC).
    - Dpkg::Vendor: Avoid duplicate file loading attempts.
    - Dpkg::Vendor: Prefer loading lowercase vendor file first as documented.
      Reported by Niels Thykier <niels@thykier.net> (on IRC).
    - Dpkg::Vendor: Prefer loading capitalized vendor modules.
    - Dpkg::Vendor: Use a normalized key to access the cached objects.
      Reported by Niels Thykier <niels@thykier.net> (on IRC).
    - Dpkg::Vendor: Fix vendor file loading for vendors with special
      characters.
    - Dpkg::Vendor: Fix module loading for vendors with special characters.
      Reported by Niels Thykier <niels@thykier.net> (on IRC).
    - Dpkg::Vendor: Deprecate loading vendor files with no special character
      mapping.
    - Dpkg::Vendor: Deprecate loading vendor module names starting lower-cased.
      Reported by Niels Thykier <niels@thykier.net> (on IRC).
    - Test::Dpkg: Refactor test files search into _test_get_files function().
    - Dselect::Ftp: Declare %CONFIG with «our» instead of «my».
    - Dselect::Ftp: Conditionally load perl modules shipped in the perl
      package.
    - Test::Dpkg: Make test_get_temp_path() remove the path before creating it.
    - Dpkg::File: Add new file_dump() function.
    - Dpkg::File: Add new file_touch() function.
    - Dpkg::OpenPGP: Remove unused $exec_opts argument from _exec_openpgp().

