=== debian/control ===
--- 
+++ 
@@ -79,6 +79,7 @@
 Multi-Arch: same
 Depends:
  ${misc:Depends},
+ libmd-dev,
  zlib1g-dev,
  liblzma-dev,
  libbz2-dev,
