## dpkg 1.21.13

=== debian/control ===
--- 
+++ 
@@ -10,15 +10,16 @@
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
- pkg-config,
-# Needed for ITS support.
+ pkgconf | pkg-config,
+# Version needed for ITS support.
  gettext (>= 0.19.7),
-# Needed for --porefs defaults, conditional addenda and mode=eof.
+# Version needed for --porefs defaults, conditional addenda and mode=eof.
  po4a (>= 0.59),
  libmd-dev,
  zlib1g-dev,
  libbz2-dev,
- liblzma-dev,
+# Version needed for multi-threaded compressor support.
+ liblzma-dev (>= 5.4.0),
  libselinux1-dev [linux-any],
  libncurses-dev (>= 6.1+20180210),
 # Needed for the functional test.
@@ -56,7 +57,7 @@
  ${shlibs:Depends},
 Depends:
  ${misc:Depends},
-# Needed for --clamp-mtime in dpkg-deb -b.
+# Version needed for --clamp-mtime in dpkg-deb -b.
  tar (>= 1.28-1),
 Suggests:
  apt,
@@ -81,7 +82,8 @@
  ${misc:Depends},
  libmd-dev,
  zlib1g-dev,
- liblzma-dev,
+# Version needed for multi-threaded compressor support.
+ liblzma-dev (>= 5.4.0),
  libbz2-dev,
 Description: Debian package management static library
  This package provides the header files and static library necessary to
@@ -99,11 +101,11 @@
  ${misc:Depends},
  ${perl:Depends},
  libdpkg-perl (= ${source:Version}),
-# Needed for --clamp-mtime.
+# Version needed for --clamp-mtime.
  tar (>= 1.28-1),
  bzip2,
  xz-utils,
-# Needed for git-style diff support.
+# Version needed for git-style diff support.
  patch (>= 2.7),
  make,
  binutils,
@@ -140,7 +142,7 @@
 Depends:
  ${misc:Depends},
  ${perl:Depends},
-# Needed for arch tuples.
+# Version needed for arch tuples.
  dpkg (>= 1.18.11),
 Recommends:
 # Used by Dpkg::File.
